Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 204 by niro, Mon Aug 22 00:07:32 2005 UTC revision 2172 by niro, Thu Aug 15 08:56:57 2013 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.34 2005-08-22 00:07:32 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  ## setup ##  # set default user mage.rc
11  PKGSUFFIX="mpk"  : ${MAGERC="/etc/mage.rc"}
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
12    
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc  source /etc/mage.rc.global
17    source ${MAGERC}
18  showversion() {  source ${MLIBDIR}/mage4.functions.sh
19   echo -en "Magellan Source Install v${SMAGEVERSION} "  source ${MLIBDIR}/smage2.functions.sh
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die() {  
  xtitleclean  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 xtitle() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum() {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources() {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  #install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? == 0 ]]  
  then  
  # md5's ok, not fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  #echo "DEBUG: ${MY_SRC_URI}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI_MIRROR}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  #echo "DEBUG: ${SRC_URI[${i}]}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
 # only needed to run through a list of mirrors  
 # if [ "$?" == "0" ]  
 # then  
 # break  
 # else  
 # continue  
 # fi  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
  echo  
  echo ">== Checking MD5 sums:"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
 mconfigure() {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall() {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake() {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack() {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 sminclude() {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
   
  #ccache + distcc together  
  if [ "${SMAGE_USE_CCACHE}" == "true" ]  
  then  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Preparing DistCC to work together with CCache ..."  
  #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"  
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
  fi  
  fi  
   
  #creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
   
 setup_ccache_environment(){  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Using CCache for compilation ..."  
  export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  #unset CC CXX  
  fi  
 }  
   
   
 # fixes given dependencies to match a MAGE_TARGET  
 # fix_mage_deps -target s/depend # <-- note -target !  
 fix_mage_deps() {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
  then  
  # fix DEPEND  
  while read sym dep  
  do  
  cat="$(dirname ${dep})"  
  # change if not virtual  
  if [[ ${cat} = virtual ]]  
  then  
  pname="$(basename ${dep})"  
  else  
  # fix pver to target-pver  
  # to get pname-target-pver  
   
  # doing it backwards !  
  pver="${dep##*-}"  
  # full pver  
  pname="$(basename ${dep/-${pver}/})${target}-${pver}"  
  fi  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
  fi  
   
  echo "${depend}"  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions wich should also be added  
 #                         warning: they get killed before the build starts !  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 #  
 # gets called with build_mage_script target  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local target  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  [ -n "$1" ] && target="-$1"  
   
  # name of magefile  
  magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"  
   
  # show what we are doing  
  echo "Generating Mage file:"  
  echo "  ${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.34 2005-08-22 00:07:32 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # special tags and vars  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
  # add special vars  
  if [ -n "${SPECIAL_VARS}" ]  
  then  
  local i  
  for i in ${SPECIAL_VARS}  
  do  
  # being tricky here :)  
  echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  # add at least all includes  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  echo >> ${dest}  
   
  # deps and provides  
  echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
  echo >> ${dest}  
20    
21   # add special functions  ## setup ##
22   if [ -n "${SPECIAL_FUNCTIONS}" ]  SMAGENAME="$1"
23   then  SMAGEVERSION="$(< ${MLIBDIR}/version)"
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  echo  >> ${dest}  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f postinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f preremove >> ${dest}  
  echo  >> ${dest}  
  typeset -f postremove >> ${dest}  
  echo  >> ${dest}  
   
  # echo MAGE_TARGETS ## note -target is needed !  
  echo "MAGE_TARGETS=\"${targets}\"" >> ${dest}  
 }  
   
 regen_mage_tree()  
 {  
  local i  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # run it without targets  
  if [ -z "${MAGE_TARGETS}" ]  
  then  
  echo  
  build_mage_script  
  echo  
  else  
   
  # build for each target an mage file  
  # run it with several targets  
  for i in ${MAGE_TARGETS}  
  do  
  echo  
  build_mage_script "${i}"  
  echo  
  done  
  fi  
  fi  
24    
25   # now unset all uneeded vars to be safe  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
26   # unset PKGNAME <-- don't do that; smage needs this var  if [[ -n ${MROOT} ]]
27   # unset to be safe (quotes needed !)  then
28   for i in ${SPECIAL_FUNCTIONS}   export PKGDIR=${MROOT}/${PKGDIR}
29   do   export BUILDDIR=${MROOT}/${BUILDDIR}
30   unset "${i}"   export BINDIR=${MROOT}/${BINDIR}
31   done  fi
  unset SPECIAL_FUNCTIONS  
  for i in ${SPECIAL_VARS}  
  do  
  unset "${i}"  
  done  
  unset SPECIAL_VARS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
32    
33  # print out our version  # print out our version
34  showversion  showversion
35  echo  echo
36    
37  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
38  then  then
39   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
40   echo   echo
41   exit 1   exit 1
42  fi  fi
43    
44    # load supported mage features
45    load_mage_features
46    
47  # updating smage2-scripts  # updating smage2-scripts
48  if [ "$1" == "update" ]  if [[ $1 = update ]]
49  then  then
50   if [ ! -d ${SOURCEDIR} ]   if [ ! -d ${SOURCEDIR} ]
51   then   then
# Line 663  then Line 56  then
56  fi  fi
57    
58  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
59  if [ "$1" == "calcmd5" ]  if [[ $1 = calcmd5 ]]
60  then  then
61   if [ $# -ge 3 ]   if [ $# -ge 2 ]
62   then   then
63   SMAGENAME="$2"   SMAGENAME="$2"
64   MD5DIR="$3"   MD5DIR="$3"
65   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
66    
67     smagesource ${SMAGENAME} || die "download source failed"
68    
69   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
70   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 715  then Line 110  then
110   unset my_SRC_URI_MIRROR   unset my_SRC_URI_MIRROR
111   unset my_SOURCEDIR   unset my_SOURCEDIR
112   done   done
113    
114   echo   echo
115   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
116   echo   echo
117   else   else
118   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
119   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
120   echo   echo
121   echo   echo
122   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
123   echo   echo
124   exit 1   exit 1
125   fi   fi
126    
127   exit 0   exit 0
128  fi  fi
129    
# Line 743  then Line 138  then
138   # get smage   # get smage
139   SMAGENAME="$2"   SMAGENAME="$2"
140   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
141   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
142    
143   download_sources   download_sources
144   exit 0   exit 0
# Line 755  then Line 150  then
150   # set correct SMAGENAME   # set correct SMAGENAME
151   SMAGENAME="$2"   SMAGENAME="$2"
152   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
153   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
154    
155   regen_mage_tree   regen_mage_tree
156    
157     # build several targets
158     if [[ -n ${MAGE_TARGETS} ]]
159     then
160     for target in ${MAGE_TARGETS}
161     do
162     # build md5sum for existing packages
163     generate_package_md5sum \
164     --pcat "${PCAT}" \
165     --pname "${PNAME}" \
166     --pver "${PVER}" \
167     --pbuild "${PBUILD}" \
168     --parch "${ARCH}" \
169     --target "${target}"
170     done
171    
172     # build several subpackages
173     elif [[ -n ${SPLIT_PACKAGES} ]]
174     then
175     split_save_variables
176     for subpackage in ${SPLIT_PACKAGES}
177     do
178     # get the right variables for the split
179     export PNAME="${subpackage}"
180     split_info_${subpackage}
181     # fix PCATEGORIE -> PCAT
182     if [[ ! -z ${PCATEGORIE} ]]
183     then
184     PCAT="${PCATEGORIE}"
185     unset PCATEGORIE
186     fi
187     # build md5sum for existing packages
188     generate_package_md5sum \
189     --pcat "${PCAT}" \
190     --pname "${PNAME}" \
191     --pver "${PVER}" \
192     --pbuild "${PBUILD}" \
193     --parch "${ARCH}"
194     # restore smage environment
195     split_restore_variables
196     done
197     # unset all saved smage variables
198     split_unset_variables
199    
200     else
201     # build md5sum for existing packages
202     generate_package_md5sum \
203     --pcat "${PCAT}" \
204     --pname "${PNAME}" \
205     --pver "${PVER}" \
206     --pbuild "${PBUILD}" \
207     --parch "${ARCH}"
208     fi
209    
210   exit 0   exit 0
211  fi  fi
212    
213  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
214  then  then
215   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   # set correct SMAGENAME
216  fi   SMAGENAME="$2"
217     MD5DIR="$(dirname ${SMAGENAME})/md5"
218    
219  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
 then  
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
220    
221  if [ -z "${SOURCEDIR}" ]   smagesource ${SMAGENAME} || die "regen: smage2 not found"
 then  
  die "\$SOURCEDIR not found. Please setup your mage.rc correctly."  
 fi  
222    
223  if [ -z "${SMAGESCRIPTSDIR}" ]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
224  then   then
225   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
226  fi   rm -rf ${SOURCEDIR}/${PKGNAME}
227     fi
228    
229  if [ -z "${SMAGE2RSYNC}" ]   download_sources
230  then   source_pkg_build ${SMAGENAME}
231   echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."   exit 0
  exit 1  
232  fi  fi
233    
234  if [ -z "${BINDIR}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
235  then  then
236   die "no BINDIR variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
237  fi   msetfeature "srcpkgtarball"
238    
239  if [ -z "${CHOST}" ]   # abort if given file is not a source pkg
240  then   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
  die "no CHOST variable found in /etc/mage.rc"  
 fi  
241    
242  if [ -z "${CFLAGS}" ]   # set correct SMAGENAME; use the one that the src_pkg provide
243  then   # /path/to/SOURCEDIR/PNAME/SMAGENAME
244   die "no CFLAGS variable found in /etc/mage.rc"   SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
245    
246     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
247    
248     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
249    
250     # unpack srctarball
251     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
252    
253     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
254    
255     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
256  fi  fi
257    
258  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
259  then  then
260   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
261     SMAGENAME="$2"
262  fi  fi
263    
264    [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
265    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
266     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
267    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
268    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
269    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
270    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
271    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
272    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
273    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
274    
275  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
276  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
277  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
278    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
279    
280  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
281  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
282    
283  # auto regen mage tree if requested  # auto regen mage tree if requested
284  regen_mage_tree  regen_mage_tree
285    
286    if mqueryfeature "srcpkgbuild"
287    then
288     if [[ -d ${SOURCEDIR}/${PNAME} ]]
289     then
290     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
291     rm -rf ${SOURCEDIR}/${PNAME}
292     fi
293    fi
294    
295  # download sources  # download sources
296  download_sources  mqueryfeature "srcpkgtarball" || download_sources
297    
298  # fixes some issues with these functions  # fixes some issues with these functions
299  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
300  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
301    export -f src_check || die "src_check export failed"
302  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
303    
304  # fixes some compile issues  # fixes some compile issues
305  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
306  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
307  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
308    then
309     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
310    else
311     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
312    fi
313    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
314  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
315  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
316    
   
317  # setup distcc  # setup distcc
318  # distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
319  if [ "${SMAGE_USE_DISTCC}" == "true" ]  mqueryfeature "distcc" && setup_distcc_environment
320  then  
321   setup_distcc_environment  # setup icecc
322  fi  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
323    mqueryfeature "icecc" && setup_icecc_environment
324    
325  # setup ccache  # setup ccache
326  if [ "${SMAGE_USE_CCACHE}" == "true" ]  mqueryfeature "ccache" && setup_ccache_environment
327    
328    if mqueryfeature "resume"
329  then  then
330   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
 fi  
331    
332     # setup build logging
333     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
334     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
335     then
336     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
337     fi
338     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
339    
340  # small sleep to show our settings  else
341  sleep 1   # clean up builddir if a previously one exist
342     if [ -d ${BUILDDIR} ]
343     then
344     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
345     fi
346     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
347    
348  #debug   # clean up srcdir if a previously unpacked one exist
349  #echo "CC=${CC}"   if [ -d ${SRCDIR} ]
350  #echo "CXX=${CXX}"   then
351  #echo "DISTCC_DIR=${DISTCC_DIR}"   rm -rf ${SRCDIR}
352  #echo "PATH: ${PATH}"   fi
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
353    
354  # cleans up build if a previously one exists   # clean up bindir if a previous build exist or create a new one
355  if [ -d ${BUILDDIR} ]   if [ -d ${BINDIR} ]
356  then   then
357   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BINDIR}
358     fi
359     install -d ${BINDIR} || die "couldn't create \$BINDIR."
360    
361     # clean up package temp dir if a previous build exist
362     if [ -d ${BUILDDIR}/${PKGNAME} ]
363     then
364     rm -rf ${BUILDDIR}/${PKGNAME}
365     fi
366    
367     # clean up stamps dir
368     if [ -d ${BUILDDIR}/.stamps ]
369     then
370     rm -rf ${BUILDDIR}/.stamps
371     fi
372    
373     # setup build logging
374     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
375     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
376  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
377    
378  # cleans up srcdir if a previously unpacked one exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -d ${SRCDIR} ]  
379  then  then
380   rm -rf ${SRCDIR}   echo "virtual package detected; nothing will be build ..."
381     # automatically set !pkgbuild here too
382     msetfeature "!pkgbuild"
383    else
384     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
385     die_pipestatus 0 "src_prepare failed"
386     resume_stamp src_prepare
387     step_by_step src_prepare
388    
389     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
390     die_pipestatus 0 "src_compile failed"
391     resume_stamp src_compile
392     step_by_step src_compile
393    
394     # only run checks if requested
395     if mqueryfeature "!check"
396     then
397     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
398     else
399     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
400     die_pipestatus 0 "src_check failed"
401     resume_stamp src_check
402     fi
403     step_by_step src_check
404    
405     # build several subpackages
406     if [[ -n ${SPLIT_PACKAGES} ]]
407     then
408     # save bindir & pname
409     split_save_variables
410     export SAVED_BINDIR="${BINDIR}"
411     for subpackage in ${SPLIT_PACKAGES}
412     do
413     split_info_${subpackage}
414     if [[ ${PKGTYPE} = virtual ]]
415     then
416     echo
417     echo -en "${COLBLUE}*** ${COLDEFAULT}"
418     echo -en "Virtual package detected"
419     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
420     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
421    
422     echo "virtual package detected; nothing will be build ..."
423     # automatically set !pkgbuild here too
424     msetfeature "!pkgbuild"
425     else
426     if typeset -f src_install_${subpackage} > /dev/null
427     then
428     # export subpackage bindir
429     export BINDIR="${SAVED_BINDIR}_${subpackage}"
430     # export PNAME, several internal function and include
431     # rely on this variable
432     export PNAME="${subpackage}"
433    
434     echo
435     echo -en "${COLBLUE}*** ${COLDEFAULT}"
436     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
437     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
438     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
439    
440     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
441     die_pipestatus 0 "src_install_${subpackage} failed"
442     resume_stamp src_install_${subpackage}
443     step_by_step src_install_${subpackage}
444     fi
445     fi
446     # restore smage environment
447     split_restore_variables
448     done
449     # unset all saved smage variables
450     split_unset_variables
451     else
452     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
453     die_pipestatus 0 "src_install failed"
454     resume_stamp src_install
455     step_by_step src_install
456     fi
457  fi  fi
458    
459  # cleans up bindir if a previous build exists or creates a new one  # echo for sake of good-looking
460  if [ -d ${BINDIR} ]  echo
461    
462    if mqueryfeature "!compressdoc"
463  then  then
464   rm -rf ${BINDIR}   echo -e "!compressdoc detected; documentation will not be compressed ..."
465    elif mqueryfeature "!pkgbuild"
466    then
467     echo "!pkgbuild detected; skipping documentation compression..."
468    else
469     # compressing doc, info & man files
470     if [[ -n ${SPLIT_PACKAGES} ]]
471     then
472     # save smage environment
473     split_save_variables
474     for subpackage in ${SPLIT_PACKAGES}
475     do
476     # honor split_info
477     split_info_${subpackage}
478     if [[ ${PKGTYPE} = virtual ]]
479     then
480     # automatically set !pkgbuild here too
481     msetfeature "!pkgbuild"
482     fi
483    
484     if mqueryfeature "!compressdoc"
485     then
486     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
487     elif mqueryfeature "!pkgbuild"
488     then
489     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
490     else
491     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
492     resume_stamp post-mcompressdoc_${subpackage}
493     fi
494     # restore smage environment
495     split_restore_variables
496     done
497     # unset saved variables
498     split_unset_variables
499     else
500     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
501     resume_stamp post-mcompressdoc
502     fi
503  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
504    
505  # cleans up package temp dir if a previous build exists  if mqueryfeature "!libtool"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
506  then  then
507   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
508     then
509     echo "!pkgbuild detected; skipping libtool archive stripping ..."
510     else
511     if [[ -n ${SPLIT_PACKAGES} ]]
512     then
513     # save smage environment
514     split_save_variables
515     for subpackage in ${SPLIT_PACKAGES}
516     do
517     # honor split_info
518     split_info_${subpackage}
519     if [[ ${PKGTYPE} = virtual ]]
520     then
521     # automatically set !pkgbuild here too
522     msetfeature "!pkgbuild"
523     fi
524    
525     if mqueryfeature "!libtool"
526     then
527     if mqueryfeature "!pkgbuild"
528     then
529     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
530     else
531     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
532     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
533     resume_stamp post-mstriplibtoolarchive_${subpackage}
534     fi
535     fi
536    
537     # restore smage environment
538     split_restore_variables
539     done
540     # unset saved variables
541     split_unset_variables
542     else
543     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
544     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
545     resume_stamp post-mstriplibtoolarchive
546     fi
547     fi
548  fi  fi
549    
550  # cleans up timestamp if one exists  if mqueryfeature "purge"
 if [ -f /var/tmp/timestamp ]  
551  then  then
552   mage rmstamp   if mqueryfeature "!pkgbuild"
553  fi   then
554     echo "!pkgbuild detected; skipping file purgation ..."
555     else
556     if [[ -n ${SPLIT_PACKAGES} ]]
557     then
558     # save smage environment
559     split_save_variables
560     for subpackage in ${SPLIT_PACKAGES}
561     do
562     # honor split_info
563     split_info_${subpackage}
564     if [[ ${PKGTYPE} = virtual ]]
565     then
566     # automatically set !pkgbuild here too
567     msetfeature "!pkgbuild"
568     fi
569    
570  src_prepare || die "src_prepare failed"   if mqueryfeature "purge"
571  src_compile || die "src_compile failed"   then
572  src_install || die "src_install failed"   if mqueryfeature "!pkgbuild"
573     then
574     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
575     else
576     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
577     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
578     resume_stamp post-mpurgetargets_${subpackage}
579     fi
580     fi
581    
582     # restore smage environment
583     split_restore_variables
584     done
585     # unset saved variables
586     split_unset_variables
587     else
588     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
589     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
590     resume_stamp post-mpurgetargets
591     fi
592     fi
593    fi
594    
595  # compressing doc, info & man files  # stripping all bins and libs
596  echo -e "Compressing man-pages ..."  if mqueryfeature "!strip"
597  if [ -d ${BUILDDIR}/builded/usr/share/man ]  then
598     echo -e "!strip detected; package will not be stripped ..."
599    elif mqueryfeature "!pkgbuild"
600  then  then
601   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   echo "!pkgbuild detected; skipping stripping of the package ..."
602    else
603     if [[ -n ${SPLIT_PACKAGES} ]]
604     then
605     # save smage environment
606     split_save_variables
607     for subpackage in ${SPLIT_PACKAGES}
608     do
609     # honor split_info
610     split_info_${subpackage}
611     if [[ ${PKGTYPE} = virtual ]]
612     then
613     # automatically set !pkgbuild here too
614     msetfeature "!pkgbuild"
615     fi
616    
617     if mqueryfeature "!strip"
618     then
619     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
620     elif mqueryfeature "!pkgbuild"
621     then
622     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
623     else
624     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
625     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
626     resume_stamp post-mstripbins_${subpackage}
627     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
628     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
629     resume_stamp post-mstriplibs_${subpackage}
630     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
631     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
632     resume_stamp post-mstripstatic_${subpackage}
633     fi
634    
635     # restore smage environment
636     split_restore_variables
637     done
638     # unset saved variables
639     split_unset_variables
640     else
641     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
642     run_resume post-mstripbins || mstripbins ${BINDIR}
643     resume_stamp post-mstripbins
644     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
645     run_resume post-mstriplibs || mstriplibs ${BINDIR}
646     resume_stamp post-mstriplibs
647     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
648     run_resume post-mstripstatic || mstripstatic ${BINDIR}
649     resume_stamp post-mstripstatic
650     fi
651  fi  fi
652    
653  echo -e "Compressing info-pages ..."  if mqueryfeature "qalint"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
654  then  then
655   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   if mqueryfeature "!pkgbuild"
656     then
657     echo "!pkgbuild detected; skipping QA lint checks ..."
658     else
659     if [[ -n ${SPLIT_PACKAGES} ]]
660     then
661     # save smage environment
662     split_save_variables
663     for subpackage in ${SPLIT_PACKAGES}
664     do
665     # honor split_info
666     split_info_${subpackage}
667     if [[ ${PKGTYPE} = virtual ]]
668     then
669     # automatically set !pkgbuild here too
670     msetfeature "!pkgbuild"
671     fi
672    
673     if mqueryfeature "qalint"
674     then
675     if mqueryfeature "!pkgbuild"
676     then
677     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
678     else
679     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
680     mqalint ${BINDIR}_${subpackage}
681     fi
682     fi
683    
684     # restore smage environment
685     split_restore_variables
686     done
687     # unset saved variables
688     split_unset_variables
689     else
690     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
691     mqalint ${BINDIR}
692     fi
693     fi
694  fi  fi
695    
696  # stripping all bins and libs  if mqueryfeature "!pkgbuild"
697  case ${NOSTRIP} in  then
698   true|TRUE|yes|y)   echo -e "!pkgbuild detected; Package will not be build ..."
699   echo -e "NOSTRIP=true detected; Package will not be stripped ..."  else
700   ;;   # build several targets
701   *)   if [[ -n ${MAGE_TARGETS} ]]
  echo -e "Stripping binaries ..."  
  mstripbins ${BINDIR}  
  echo -e "Stripping libraries ..."  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 # the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
  # build serveral targets  
  if [ -n "${MAGE_TARGETS}" ]  
702   then   then
703   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
704   do   do
705   # check if an special target_pkgbuild exists   # check if a special target_pkgbuild exists
706   if typeset -f ${target}_pkgbuild > /dev/null   if typeset -f ${target}_pkgbuild > /dev/null
707   then   then
708   # run it   # run it
709   ${target}_pkgbuild   run_resume post-${target}_pkgbuild || ${target}_pkgbuild
710     resume_stamp post-${target}_pkgbuild
711   fi   fi
712   # now create the target package   # now create the target package
713   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${target} || ${MLIBDIR}/pkgbuild_dir.sh \
714   "${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD}" \   "${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
715   ${BINDIR} || die "target: ${target} package-build failed"   ${BINDIR} || die "target: ${target} package-build failed"
716   echo -e "\nPackage ${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD} successfully builded.\n"   resume_stamp post-pkg_builddir_${target}
717    
718     # build pkg-md5-sum if requested
719     run_resume post-md5sum_${target} || generate_package_md5sum \
720     --pcat "${PCAT}" \
721     --pname "${PNAME}" \
722     --pver "${PVER}" \
723     --pbuild "${PBUILD}" \
724     --parch "${ARCH}" \
725     --target "${target}"
726     resume_stamp post-md5sum_${target}
727    
728     echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
729   done   done
730    
731     # build several subpackages
732     elif [[ -n ${SPLIT_PACKAGES} ]]
733     then
734     split_save_variables
735     for subpackage in ${SPLIT_PACKAGES}
736     do
737     # get the right variables for the split
738     export PNAME="${subpackage}"
739     split_info_${PNAME}
740     # fix PCATEGORIE -> PCAT
741     if [[ ! -z ${PCATEGORIE} ]]
742     then
743     PCAT="${PCATEGORIE}"
744     unset PCATEGORIE
745     fi
746     if [[ ${PKGTYPE} = virtual ]]
747     then
748     # automatically set !pkgbuild here too
749     msetfeature "!pkgbuild"
750     fi
751    
752     # jump to next one if !pkgbuild is set in split_info
753     if mqueryfeature "!pkgbuild"
754     then
755     # restore smage environment
756     split_restore_variables
757     continue
758     fi
759    
760     # check if an special subpackage_pkgbuild exists
761     if typeset -f ${PNAME}_pkgbuild > /dev/null
762     then
763     # run it
764     run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
765     resume_stamp post-${PNAME}_pkgbuild
766     fi
767     # now create the target package
768     run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
769     "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
770     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
771     resume_stamp post-pkg_builddir_${PNAME}
772    
773     # build pkg-md5-sum if requested
774     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
775     --pcat "${PCAT}" \
776     --pname "${PNAME}" \
777     --pver "${PVER}" \
778     --pbuild "${PBUILD}" \
779     --parch "${ARCH}"
780     resume_stamp post-md5sum_${PNAME}
781    
782     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
783    
784     # restore smage environment
785     split_restore_variables
786     done
787     # unset all saved smage variables
788     split_unset_variables
789    
790   else   else
791   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
792   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   resume_stamp post-pkg_builddir
793    
794     # build pkg-md5-sum if requested
795     run_resume post-md5sum || generate_package_md5sum \
796     --pcat "${PCAT}" \
797     --pname "${PNAME}" \
798     --pver "${PVER}" \
799     --pbuild "${PBUILD}" \
800     --parch "${ARCH}"
801     resume_stamp post-md5sum
802    
803     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
804     fi
805    
806     # build src-pkg-tarball if requested
807     if mqueryfeature "srcpkgbuild"
808     then
809     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
810     resume_stamp post-srcpkgbuild
811   fi   fi
812   ;;  fi
813  esac  
814    if mqueryfeature "buildlog"
815    then
816     bzip2 -9f /var/log/smage/${PKGNAME}.log
817    else
818     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
819    fi
820    
 # for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
821  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.204  
changed lines
  Added in v.2172